package uk.ac.rdg.resc.jstyx.server;

import java.util.*;
import net.tinyos.util.*;
import net.tinyos.message.*;
import net.tinyos.tools.*;
import net.tinyos.deluge.*;

/*
  One of these to talk to each mote in the network.
  Each file would store a reference to the mote corresponding to it.
*/
//public class EPMote extends MoteIF 
public class EPMote  
{
    /* there may be a lot of different motes in the network and this specifies which */
    private int moteid; 
    private byte tag;
    public EPMsgR rtnpkt; // to send back the return packet
    public EPMsgNotifier rtnNotifier; // this actually also sends pkts out :)
    public Vector EventResponseVec;

    public static final int TIMEOUT = 50;

    static {
	/* an object to process callbacks for return messages */
	System.out.println("creating mote!");

    }

    public EPMote(int moteid, EPMsgNotifier returnNotifier)
    {
	this.moteid = moteid;
	System.out.println("registering listener\n");
	rtnNotifier = returnNotifier;
	this.tag = 1; /* 1 initially 'cause this is flipped before sending */
	returnNotifier.registerNotify(this);
	EventResponseVec = new Vector();
    }

    public int get_moteid()
    {
	return moteid;
    }

    public void set_moteid(int id)
    {
	this.moteid = id;
    }

    public synchronized void sendrecv(EPMsg pkt, EPMsgR rtnpkt) throws Exception
    {
	this.send(pkt, rtnpkt, false);
	//	Thread.currentThread().sleep(TIMEOUT);
	Thread.sleep(TIMEOUT);
	while (!rtnpkt.getrecvd()) {
	    this.send(pkt, rtnpkt, true);
	    Thread.sleep(700);
	    //	    Thread.sleep(1000);

	}
    }
	
    public synchronized void send(EPMsg pkt, EPMsgR rtnpkt, boolean retry) throws Exception 
    {
	if (!retry) 
	    this.tag = (byte)(1 - this.tag);
	pkt.set_tag(this.tag);
	rtnpkt.clrrecvd();
	this.rtnpkt = rtnpkt;


	rtnNotifier.send(moteid, pkt);
    }

    public synchronized void send(DelugeAdvMsg advMsg) throws Exception 
    {
	rtnNotifier.send(MoteIF.TOS_BCAST_ADDR, advMsg);
    }

    public void registerEventHandler(EventResponse er)
    {
	EventResponseVec.add(er);
    }

    public void messageReceived(Message m)  
	{


	    if ((((EPMsgR)m).get_sensorid()) == this.moteid) {
		if (((EPMsgR) m).get_tag() != (byte)(this.tag)) {
		    System.out.println("Invalid tag for sensor <"+ this.moteid + ">, dropping packet.");
		    return;
		}
		if (this.rtnpkt == null) {
		    System.out.println("ouch! this.rtnpkt is null");
		    return;
		}
		if (((EPMsgR) m).get_type() == SNFS.S_Revent) {

		    Enumeration e = EventResponseVec.elements();
		    while (e.hasMoreElements()) {
			 EventResponse er = (EventResponse) e.nextElement();
			 //		 System.out.println("er rid = "+er.getrid()+", msg rid = "+((EPMsgR) m).get_arg());
			 er.Response((byte)((EPMsgR) m).get_arg());
			 return;
			 /*
			 if (er.getrid() == ((EPMsgR) m).get_arg()) {
			     er.Response((byte)((EPMsgR) m).get_arg());
			     return;
			 }
			 */
		    }
		    return;
		}
	    
		
		rtnpkt.copyMsg((EPMsgR) m);

		/*
		System.out.println("rtnptk[0] = "+ (int)rtnpkt.data[0]);
		System.out.println("rtnptk[1] = "+ (int)rtnpkt.data[1]);
		System.out.println("rtnptk[2] = "+ (int)rtnpkt.data[2]);
		System.out.println("rtnptk[3] = "+ (int)rtnpkt.data[3]);
		System.out.println("rtnptk[4] = "+ (int)rtnpkt.data[4]);
		System.out.println("rtnptk[5] = "+ (int)rtnpkt.data[5]);
		System.out.println();
		*/		

		rtnpkt.setrecvd();

		
	    }
	}

}
