package uk.ac.rdg.resc.jstyx.server;

import java.util.*;
import net.tinyos.util.*;
import net.tinyos.message.*;
import net.tinyos.tools.*;

/*
  This class is used to allow multiple sensor files to access their respective sensors within TOSSIM
*/

public class EPMsgNotifier implements MessageListener
{
    private Vector NotifyVec;
    private static MoteIF mote;

    public EPMsgNotifier() {
	NotifyVec = new Vector();
	mote = new MoteIF(PrintStreamMessenger.err);
	System.out.println("****** creating listener in notify");
	mote.registerListener(new EPMsgR(), this);	
    }

    public void registerNotify(EPMote epm)
    {
	NotifyVec.add(epm);
    }

    public void send(int moteid, Message m)
    {
	try
	    {
		mote.send(moteid, m);
	    }
	catch(Exception e) 
	    {
		e.printStackTrace();
	    }	
    }

    public void messageReceived(int dest_addr, Message m)  
    {
	Enumeration e = NotifyVec.elements();
	while (e.hasMoreElements()) {
	    EPMote epm = (EPMote) e.nextElement();

	    if ((((EPMsgR)m).get_sensorid()) == epm.get_moteid()) {
	      epm.messageReceived(m);

	      return;
	    }
	     
	}
	System.out.println("recvd orphan packet for no mote");
    }
		
	
}
    
