#define MAX_FIDS 1024
#define FID_AVAILABLE 0
#define FID_UNAVAILABLE 1

unsigned char fids[MAX_FIDS];
int nextFid = 0;
int bInitialized = 0;

static void init() {
  int i;
  for (i = 0; i < MAX_FIDS; i++) {
    fids[i] = FID_AVAILABLE;
  }
}

static int getNextFid() {
  int i = nextFid;

  do {
    if (fids[i] == FID_AVAILABLE) {
      nextFid = (i + 1) % MAX_FIDS;
      return i;
    } else {
      i = (i + 1) % MAX_FIDS;
    }
  } while (i != nextFid);
  
  return -1;
}


extern int getFid() {
  int newFid;
  if (!(bInitialized)) {
    init();
    bInitialized = 1;
  }
  newFid = getNextFid();
  fids[newFid] = FID_UNAVAILABLE;
  return newFid;
}


extern void releaseFid(int fid) {
  fids[fid] = FID_AVAILABLE;
}


