#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include "slib.h"

int rd, wr;

int cnct(char *servername, int portno)
{
  struct sockaddr_in serv_addr;
  struct hostent* server;
  int sockfd;

  sockfd = socket(AF_INET, SOCK_STREAM, 0);
  server = gethostbyname(servername);
  bzero((char*) &serv_addr, sizeof(serv_addr));
  serv_addr.sin_family = AF_INET;
  bcopy((char*) server->h_addr,
        (char*) &serv_addr.sin_addr.s_addr,
        server->h_length);
  serv_addr.sin_port = htons(portno);
  // ready to connect now
  if(connect(sockfd, (struct sockaddr*)&serv_addr, sizeof(serv_addr)) < 0) {
    fprintf(stderr, "ERROR connecting\n");
    exit(0);
  }
  rd = sockfd;
  wr = sockfd;
  fprintf(stderr,"sockfd %d\n", sockfd);
}
    


main(int argc, char** argv)
{
  char buf[101];
  int cnt;
  Dir d;
  int offset;
  Qid rootqid;
  int rootfid, afid;
  Qid tempqid;
  int memfid, regfid, statusfid, controlfid; 
  char cmd; // for single letter control commands

  //  rd = dup(fileno(stdin));
  //  wr = dup(fileno(stdout));

  cnct(argv[1], atoi(argv[2]));

  rootfid = 0; memfid = 1; regfid = 2; statusfid = 3; controlfid = 4;

  if (styx_attach(rootfid, &rootqid) == STYX_ERROR) {
    fprintf(stderr,"unable to attach, exiting.\n");
    exit(-1);
  }

  if (styx_clone(rootfid, controlfid) == STYX_ERROR) {
    fprintf(stderr, "Error cloning root, exiting\n");
    exit(-1);
  }
  if (styx_walk(controlfid, "b", &tempqid) == STYX_ERROR) {
    fprintf(stderr, "error walking to b\n");
    exit(-1);
  }
  if (styx_walk(controlfid, "c", &tempqid) == STYX_ERROR) {
    fprintf(stderr, "error walking to c\n");
    exit(-1);
  }

  if (styx_open(controlfid, OREAD) == STYX_ERROR) {
    fprintf(stderr, "error opening c\n");
    exit(-1);
  }

  if ((cnt = styx_read(controlfid, 0, 100, buf)) == STYX_ERROR)
    {
      fprintf(stderr, "error reading c\n");
      exit(-1);
    }

  buf[cnt] = 0;
  fprintf(stderr, "buffer[%d]: %s\n", cnt, buf);
}
