/*
 * flash.h : the header file for all supported flashes
 *
 * Copyright (C) 2003, Rongkai zhan <zhanrk@163.com>
 */

/* $Id: flash.h,v 1.1.1.1 2007/06/05 20:06:30 bpisupat Exp $ */

#ifndef JTAGER_FLASH_H
#define JTAGER_FLASH_H

#include "types.h"

typedef struct flash_chip_struct {
	char *name; /* the flash chip name string */
	u16 mfr_id; /* Manuafracture ID */
	u16 dev_id; /* Device ID */
	u32 base; /* the physical base address */
	int chip_size; /* how many bytes the whole chip has */
	int sector_size; /* how many bytes per sector */
	int bus_width; /* it can only be 8, 16 or 32 */

	/* flash operations */
	int (* probe) (u32 base);
	int (* erase_sector) (u32 addr);
	int (* erase_chip) (void);
	int (* write) (u32 start_address, u32 bytenr, u32 source_address, int from_host);
}flash_t;

/* from flash.c */
extern flash_t *flashes[];
extern flash_t *flash; /* the current selected flash chip */

extern flash_t *flash_index(char *flash_name);

extern int mtd_init(void);
extern int mtd_erase(u32 addr, u32 bytenr);
extern int mtd_write(u32 addr, u32 bytenr, u8 *buf);

#endif /* !JTAGER_FLASH_H */
