/*========================================================================*\
|                                                                          |
| Flash.h                                                                  |
|                                                                          |
| This file contains the FLASH memory functions header                     |
|--------------------------------------------------------------------------|
| Project:              MSP430 JTAG interfcae                              |
| Developed using:      MS Visual C++ 5.0                                  |
|--------------------------------------------------------------------------|
| Author:               Dale Wellborn                                      |
| Version:              1.1.5                                              |
| Initial Version:      20 / 07 / 02                                       |
| Last Change:          01/21/ 02                                          |
|--------------------------------------------------------------------------|
| Version history:                                                         |
| Version: 1.1.5                                                           |
| 01.12.2003 UPSF added writeFlash and eraseFlash function from MSP430.c   |
|                 changed some parameter to long                           |
| 01/21/2004 UPSF support for F1611                                        |
| 29.02.2004 UPSF Added setupMarginalReadFlash                             |
|                                                                          |
|                                                                          |
|--------------------------------------------------------------------------|
| Designed 2002 by Texas Instruments                                       |
\*========================================================================*/

/*------------------------------------------------------------------------*\
| Remarks:                                                                 |
|                                                                          |
\*------------------------------------------------------------------------*/


#ifndef _FLASH_H_
#define _FLASH_H_

extern BOOL programFrequencySet;
extern BOOL eraseFrequencySet;

// Functions. -----------------------------------------------------------------

STATUS_T writeFlash(LONG address, BYTE* buffer, LONG count);
STATUS_T eraseFlash(LONG type, LONG address, LONG length);
STATUS_T setupMarginalReadFlash(LONG type);

#endif // _FLASH_H_
