#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include "dat.h"
#include "arch/thread.h"
#include "error.h"
#include "system.h"
#include "altera_avalon_uart_regs.h"
#include "arch/uart.h"


//#define DEBUG(str) if (log) printf("%s",str);



//#define error(str) printf("Error:%s\n", str); 
//#define error(str)


extern char log;

/* pipe for incoming packets - this passes entire fcalls *
 *  unlike a few others that pass pointers               */
extern Channel inChan;

/* pipe for outgoing packets */
extern Channel outChan;

extern Channel rtnbufferChan;

/* tcp socket for read-write */
extern int sa;

const unsigned char msglen[] = {
  3,  // Tnop
  3,  // Rnop
  0,  // Terror (illegal, haha)
  67, // Rerror
  5,  // Tflush
  3,  // Rflush
  7,  // Tclone
  5,  // Rclone
  33, // Twalk
  13, // Rwalk
  6,  // Topen
  13, // Ropen
  38, // Tcreate
  13, // Rcreate
  15, // Tread
  8,  // Rread
  16, // Twrite
  7,  // Rwrite
  5,  // Tclunk
  5,  // Rclunk
  5,  // Tremove
  5,  // Rremove
  5,  // Tstat
  121,// Rstat
  121,// Twstat
  5,  // Rwstat
  0,  // Tsession
  0,  // Rsession
  61, // Tattach
  13  // Rattach
};


extern int sa;

/*
 This is a platform specific form instance of this function.
 It is supposed to keep accepting packets to be sent out.

*/

/*
void myprintf(char *str)
{
  int i;
  volatile int uval;
  
  for(i= 0; i < strlen(count), i++) {
    
     while (1) {
      uval = (IORD_ALTERA_AVALON_UART_STATUS(UART1_BASE) & ALTERA_AVALON_UART_STATUS_TRDY_MSK);
      if (uval)
        break;
     }
      
      IOWR_ALTERA_AVALON_JTAG_UART_DATA(JTAG_UART_BASE, str[i]);
  }
}
  */  

void
putfcall()
{
  int len; 
  static Fcall *tx;
  int sent;
  static int n;
  static u_int8_t ch1, ch2;
  volatile int uval;

  threadBegin();

  while(1) {    /* forever .... */
    if (chanrecv(&outChan, &tx) < 0)
      threadReturn();
    printf("putfcall:: received packet of type:%d\n",tx->type);
    len = (tx->type >= sizeof(msglen)) ? 0 : msglen[tx->type];
    if (tx->type == Twrite)
      len += tx->ns.un.Twrf.count;
    if (tx->type == Rread)
      len += tx->ns.un.Rwrf.rcount;
      
    /* This should really be in uart.c
     * But then we cannot yeild while the data is being sent ...*/  
    printf("pfc:%d\n",(int)tx->type);
    for(n=0;n<len;n++) {
     ch1 = *((u_int8_t *)&tx->type + n) & 0xF;
     ch2 = *((u_int8_t *)&tx->type + n) >> 4;
     
     ch1 = ch1+'0';
     ch2 = ch2+'0';
     
     /*  first send LSN */
     while (1) {
      uval = (IORD_ALTERA_AVALON_UART_STATUS(UART1_BASE) & ALTERA_AVALON_UART_STATUS_TRDY_MSK);
      if (!uval)
        threadReturn();
       else 
        break;
     }  
     IOWR_ALTERA_AVALON_UART_TXDATA(UART1_BASE, ch1);
 //    IOWR_ALTERA_AVALON_UART_TXDATA(UART1_BASE, tx->type );
     
     /*  next send MSN */
     while (1) {
      uval = (IORD_ALTERA_AVALON_UART_STATUS(UART1_BASE) & ALTERA_AVALON_UART_STATUS_TRDY_MSK);
      if (!uval)
        threadReturn();
       else 
        break;
     }  
     IOWR_ALTERA_AVALON_UART_TXDATA(UART1_BASE, ch2);
 //  IOWR_ALTERA_AVALON_UART_TXDATA(UART1_BASE, tx->type);
 
     
     
    printf("pfc :%d\n", *((u_int8_t *)&tx->type + n));
    }  
       
    if (channbsend( &rtnbufferChan, &tx) == LASTALT)
      printf("WARNING: rtnbuf thread unable to return buffer\n");
  }
  threadFinish();
}



void getfcall()
{

  /* error recovery here is poor -- what should we do ? */

  static  Fcall *fc;
  static Fcall fstr;
  static int i;
  static int cnt;
 
  int inc;
  
  static int len;

  threadBegin();

  
  fc = &fstr;
  while(1) {

    while (1)
	  {
      if ((inc = mygetchar()) < 0)
         threadReturn(); 
	   else {
         fc->type = (u_int8_t)inc;
	       break;
     }
	  }

    len = (fc->type >= sizeof(msglen)) ? 0 : msglen[fc->type];
    printf("getfcall: received pkt, forwarding to serve, type = %d\n",fc->type);  
  
    for(i = 0;i<(len - 1); i++) {
     while (1) { 
       if ((inc = mygetchar()) < 0)
            threadReturn(); 
          else {
           *((u_int8_t *)(&fc->tag) + i) = (u_int8_t) inc;
            break;
          }
     }
    }
  
    if (fc->type == Rread) {  
      for(i = 0;i<fc->ns.un.Rwrf.rcount ; i++) {
       while (1) { 
         if ((inc = mygetchar()) < 0)
              threadReturn(); 
            else {
             *((u_int8_t *)&fc->ns.un.Rwrf.rdata + i) = (u_int8_t) inc;
              break;
            }
       }
      }  
    } 
     
    // need to truncate if too large !!
    
    if (fc->type == Twrite) {  
     	cnt = fc->ns.un.Twrf.count > sizeof(fc->ns.un.Twrf.data) ? sizeof(fc->ns.un.Twrf.data) : fc->ns.un.Twrf.count;
	
      for(i = 0;i<cnt ; i++) {
       while (1) { 
         if ((inc = mygetchar()) < 0)
              threadReturn(); 
            else {
             *((u_int8_t *)&fc->ns.un.Twrf.data + i) = (u_int8_t) inc;
              break;
            }
       }
      }  
    }
  
      
    printf("getfcall: received pkt, forwarding to serve, type = %d\n",fc->type);
    if (chansend(&inChan, fc) < 0)
  	 threadReturn();
    }
  threadFinish();
}  
