#ifndef DAT_H
#define DAT_H

#include <setjmp.h>
#include "styx.h"
#include "error.h"
#include "arch/thread.h"
#define USED(x) if(x){}else{}

#define KNAMELEN 28
#define DEVDOTDOT -1
#define NERR 10

/* indices for pipes */
#define GETCALLINDEX 0
#define PUTCALLINDEX 1
#define BUFRTNINDEX 2
#define TESTINDEX 3
#define TREEINDEX 4

// the index of alt array where we store either CHANEND or CHAN_NOBLK
#define LASTALT 1

//#define poperror() up->nerr--
//#define waserror() (up->nerr++, setjmp(up->estack[up->nerr-1]))
//#define nexterror() longjmp(up->estack[--up->nerr], 1)
//#define error(err) (strncpy(up->errstr, err, ERRMAX), nexterro
//#define error1(errstruct, err) (strncpy(errstruct.errstr, err, ERRREC), longjmp(errstruct.estack, 0))

//#define errorptr(errstructptr, err) (strncpy(errstructptr->errstr, err, ERRREC), longjmp(errstructptr->estack, 0))


#define nelem(x) (sizeof(x)/sizeof((x[0])))
#define nil 0

typedef unsigned char uchar;
typedef long vlong;

typedef struct iFid iFid;
typedef struct Dev Dev;
typedef struct Dirtab Dirtab;
typedef struct Proc Proc;



/*
 * Access types in namec & channel flags
 */
enum
  {
    COPEN   = 0x0001,               /* for i/o */
    CMSG    = 0x0002,               /* the message channel for a mount */
    CFREE   = 0x0010                /* not in use */
  };

enum
  {
    PDIR    = 0x8
  };

struct iFid
{
  int fidno;       /* fid value assigned by client; server can create pseudo fids for marking mount points  */
  ushort type;   /* device                  */
  ulong  dev;    /* dev number              */
  Qid9p  qid;    /* device qid              */
  ushort mode;   /* read/write              */
  ushort flag;   /* open ?                  */
  long   offset; /* in file                 */
  long   dri;    /* directory read index    */
  iFid *next;
  iFid *prev;
  //  Chan   *from;  /* for mounted file system */
};

/*
struct ErrorStruct
{
  char errstr[ERRREC];
  jmp_buf estack;
};
*/


/* 
 *  all operations return error code
 */

struct Dev
{
  char	dc;
  char*	name;
  Channel *cpipe; /* pipe thru which serve talks to the device */
  Channel *cfidpipe;

  void	(*init)(Dev *o);
  void	(*attach)(iFid **, char *);
  void  (*clone)(iFid **, iFid *);
  void  (*walk)(iFid*, char * );
  void	(*stat)(iFid*, Dir*, ErrorStruct *);
  void	(*open)(iFid**, int, ErrorStruct *);
  void	(*create)(iFid*, char*, int, ulong);
  void	(*close)(iFid*);
  void	(*read)(iFid*, void*, ushort, vlong, ushort *);
  void	(*write)(iFid*, void*, ushort , vlong, ushort *);
  void	(*remove)(iFid*, ErrorStruct*);
  void	(*wstat)(iFid*, Dir *, ErrorStruct *);
};



struct Dirtab {
  char name[KNAMELEN];
  u_int8_t qid;
  u_int8_t link1;
  u_int8_t perm;
};

extern Dev *devtab[];
extern Proc *up;


#endif
